/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.curve.building; 

import java.util.LinkedHashMap; 
import java.util.Set; 

import org.apache.commons.lang.ObjectUtils; 

import com.opengamma.util.ArgumentChecker; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * Class describing a block of curves build together.
 */
    CurveBuildingBlock {
	

  /**
   * The list of curve in the block as a map: Name to a pair of integers: 
   *   1) Start of the curve parameters in the array of all parameters of the block. 2) Number of parameters in the curve
   */
  

	

  /**
   * Constructor from a map. A new map is created.
   * @param block The curve block. Not null.
   */
  

	

  /**
   * Returns the start index of the given string in the array of all parameters.
   * @param name The string name.
   * @return The start index.
   */
  

	

  /**
   * Returns the number of parameters for the curve.
   * @param name The curve name.
   * @return The number of parameters.
   */
  

	

  /**
   * Returns a set with all the curve names.
   * @return The set of names.
   */
  

	

  

	

  


}
