/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.interestrate.future.method; 

import java.util.ArrayList; 
import java.util.HashMap; 
import java.util.List; 
import java.util.Map; 

import com.opengamma.analytics.financial.interestrate.CashFlowEquivalentCalculator; 
import com.opengamma.analytics.financial.interestrate.CashFlowEquivalentCurveSensitivityCalculator; 
import com.opengamma.analytics.financial.interestrate.InterestRateCurveSensitivity; 
import com.opengamma.analytics.financial.interestrate.annuity.derivative.AnnuityPaymentFixed; 
import com.opengamma.analytics.financial.interestrate.future.derivative.DeliverableSwapFuturesSecurity; 
import com.opengamma.analytics.financial.model.interestrate.HullWhiteOneFactorPiecewiseConstantInterestRateModel; 
import com.opengamma.analytics.financial.model.interestrate.definition.HullWhiteOneFactorPiecewiseConstantDataBundle; 
import com.opengamma.util.tuple.DoublesPair; 
import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * Method to compute the price for an deliverable swap futures with convexity adjustment from a Hull-White one factor model.
 * <p> Reference: Henrard M., Deliverable Interest Rate Swap Futures: pricing in Gaussian HJM model, September 2012.
 */
    DeliverableSwapFuturesSecurityHullWhiteMethod {
	

  /**
   * The unique instance of the calculator.
   */
  

	

  /**
   * Gets the calculator instance.
   * @return The calculator.
   */
  

	

  /**
   * Constructor.
   */
  

	

  /**
   * The Hull-White model.
   */
  

	
  /**
   * The cash flow equivalent calculator used in computations.
   */
  

	
  /**
   * The cash flow equivalent curve sensitivity calculator used in computations.
   */
  

	

  /**
   * Computes the futures price.
   * @param futures The futures.
   * @param curves The curves and the Hull-White parameters.
   * @return The price.
   */
  

	

  


}
