/**
 * Copyright (C) 2011 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.interestrate.market.description; 

import java.util.ArrayList; 
import java.util.HashMap; 
import java.util.List; 
import java.util.Map; 
import java.util.Set; 
import java.util.TreeSet; 

import org.apache.commons.lang.ObjectUtils; 

import com.opengamma.util.ArgumentChecker; 
import com.opengamma.util.tuple.DoublesPair; 
import com.opengamma.util.tuple.Triple; 
import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * Class describing a present value curve sensitivity.
 */
    CurveSensitivityMarket {
	

  /**
   * The map containing the sensitivity to the yield (continuously compounded) (for discounting and issuer specific curves). 
   * The map linked the curve (String) to a list of pairs (cash flow time, sensitivity value).
   */
  

	
  /**
   * The map containing the sensitivity to forward curve. The sensitivity will depend on the way the curve is described (discount factor curve, forward rate, ...) 
   * The map linked the curve (String) to a list of pairs (cash flow time, sensitivity value).
   */
  

	
  /**
   * The map containing the sensitivity to the price index. 
   * The map linked the curve (String) to a list of pairs (cash flow time, sensitivity value).
   */
  

	

  /**
   * Default constructor, creating an empty HashMap for the sensitivity.
   */
  

	

  /**
   * Constructor from a yield discounting map, a forward map and a price index curve of sensitivity. The maps are used directly.
   * @param sensitivityYieldDiscounting The map.
   * @param sensitivityForward The map.
   * @param sensitivityPriceCurve The map.
   */
  

	

  /**
   * Constructor from a yield discounting map of sensitivity. The maps are used directly.
   * @param sensitivityYieldDiscounting The map.
   * @param sensitivityForward The map.
   * @param sensitivityPriceCurve The map.
   * @return The sensitivity.
   */
  

	

  /**
   * Constructor from a yield discounting map of sensitivity. The map is used directly.
   * @param sensitivityYieldDiscounting The map.
   * @return The sensitivity.
   */
  

	

  /**
   * Constructor from a yield discounting map and a forward map. The map is used directly.
   * @param sensitivityForward The map.
   * @return The sensitivity.
   */
  

	

  /**
   * Constructor from a yield discounting map and a forward map. The maps are used directly.
   * @param sensitivityYieldDiscounting The map.
   * @param sensitivityForward The map.
   * @return The sensitivity.
   */
  

	

  /**
   * Constructor from a yield discounting map and a price map. The maps are used directly.
   * @param sensitivityYieldDiscounting The map.
   * @param sensitivityPriceCurve The map.
   * @return The sensitivity.
   */
  

	

  /**
   * Gets the discounting curve sensitivities.
   * @return The sensitivity map
   */
  

	

  /**
   * Gets the forward curve sensitivity map.
   * @return The sensitivity map
   */
  

	

  /**
   * Gets the price index curve sensitivity map.
   * @return The sensitivity map
   */
  

	

  /**
   * Create a copy of the sensitivity and add a given sensitivity to it.
   * @param other The sensitivity to add.
   * @return The total sensitivity.
   */
  

	

  /**
   * Add two maps together.
   * @param map1 The first map.
   * @param map2 The second map.
   * @return The sum.
   */
  

	

  /**
   * Add two maps links to forward curves.
   * @param map1 The first map.
   * @param map2 The second map.
   * @return The sum.
   */
  

	

  /**
   * Create a new sensitivity object containing the original sensitivity multiplied by a common factor.
   * @param factor The multiplicative factor.
   * @return The multiplied sensitivity.
   */
  

	

  

	

  

	

  /**
   * Return a new sensitivity by sorting the times and adding the values at duplicated times.
   * @return The cleaned sensitivity.
   */
  

	

  /**
   * Clean a map by sorting the times and adding the values at duplicated times.
   * @param map The map.
   * @return The cleaned map.
   */
  

	

  

	

  

	

  

	

  


}
