/**
 * Copyright (C) 2011 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.interestrate.payments.market; 

import java.util.ArrayList; 
import java.util.HashMap; 
import java.util.List; 
import java.util.Map; 

import org.apache.commons.lang.Validate; 

import com.opengamma.analytics.financial.interestrate.InstrumentDerivative; 
import com.opengamma.analytics.financial.interestrate.market.description.CurveSensitivityMarket; 
import com.opengamma.analytics.financial.interestrate.market.description.IMarketBundle; 
import com.opengamma.analytics.financial.interestrate.market.description.MultipleCurrencyCurveSensitivityMarket; 
import com.opengamma.analytics.financial.interestrate.method.PricingMarketMethod; 
import com.opengamma.analytics.financial.interestrate.payments.derivative.CouponFixed; 
import com.opengamma.util.money.MultipleCurrencyAmount; 
import com.opengamma.util.tuple.DoublesPair; 
import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * Method to compute present value and present value sensitivity for fixed coupon.
 */
    CouponFixedDiscountingMarketMethod   {
	

  /**
   * The method unique instance.
   */
  

	

  /**
   * Return the unique instance of the class.
   * @return The instance.
   */
  

	

  /**
   * Private constructor.
   */
  

	

  /**
   * Compute the present value of a Fixed coupon by discounting.
   * @param coupon The coupon.
   * @param market The market with the curves.
   * @return The present value.
   */
  

	

  

	

  /**
   * Computes the present value curve sensitivity of a fixed coupon by discounting.
   * @param cpn The coupon.
   * @param market The market with the curves.
   * @return The sensitivity.
   */
  


}
