/**
 * Copyright (C) 2011 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.interestrate.payments.market; 

import java.util.ArrayList; 
import java.util.HashMap; 
import java.util.List; 
import java.util.Map; 

import org.apache.commons.lang.Validate; 

import com.opengamma.analytics.financial.interestrate.InstrumentDerivative; 
import com.opengamma.analytics.financial.interestrate.market.description.CurveSensitivityMarket; 
import com.opengamma.analytics.financial.interestrate.market.description.IMarketBundle; 
import com.opengamma.analytics.financial.interestrate.market.description.MarketForwardSensitivity; 
import com.opengamma.analytics.financial.interestrate.market.description.MultipleCurrencyCurveSensitivityMarket; 
import com.opengamma.analytics.financial.interestrate.method.PricingMarketMethod; 
import com.opengamma.analytics.financial.interestrate.payments.derivative.CouponOIS; 
import com.opengamma.util.ArgumentChecker; 
import com.opengamma.util.money.MultipleCurrencyAmount; 
import com.opengamma.util.tuple.DoublesPair; 
import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * Method to compute present value and its sensitivities for OIS coupons.
 */
    CouponOISDiscountingMarketMethod   {
	

  /**
   * The method unique instance.
   */
  

	

  /**
   * Return the unique instance of the class.
   * @return The instance.
   */
  

	

  /**
   * Private constructor.
   */
  

	

  /**
   * Computes the present value.
   * @param coupon The coupon.
   * @param market The market curves.
   * @return The present value.
   */
  

	

  

	

  /**
   * Compute the present value sensitivity to rates of a OIS coupon by discounting.
   * @param coupon The coupon.
   * @param market The market curves.
   * @return The present value curve sensitivities.
   */
  

	

  /**
   * Computes the par rate, i.e. the fair rate for the remaining period. 
   * @param coupon The coupon.
   * @param market The market curves.
   * @return The par rate.
   */
  

	

  /**
   * Computes the par rate sensitivity to the curve rates.
   * @param coupon The coupon.
   * @param market The market curves.
   * @return The sensitivities.
   */
  


}
