/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.model.option.definition; 

import org.apache.commons.lang.ObjectUtils; 
import org.apache.commons.lang.Validate; 

import com.opengamma.analytics.financial.instrument.index.GeneratorSwapFixedIbor; 
import com.opengamma.analytics.financial.model.volatility.VolatilityModel; 
import com.opengamma.analytics.math.surface.Surface; 
import com.opengamma.util.tuple.DoublesPair; 
import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * Class describing the Black volatility surface used in swaption modeling.
 */
    BlackSwaptionParameters   {
	

  /**
   * The volatility surface. The first dimension is the expiration and the second the tenor.
   */
  

	
  /**
   * The standard swap generator (in particular fixed leg convention and floating leg tenor) for which the volatility surface is valid.
   */
  

	

  /**
   * Constructor from the parameter surfaces. The default SABR volatility formula is HaganVolatilityFunction.
   * @param volatility The Black volatility surface.
   * @param generatorSwap The standard swap generator for which the volatility surface is valid.
   */
  

	

  /**
   * Return the volatility for a pair of time to expiration and instrument tenor.
   * @param expiryMaturity The expiration/tenor pair.
   * @return The volatility.
   */
  

	

  /**
   * Return the volatility for a pair of time to expiration and instrument tenor.
   * @param expiry The time to expiration
   * @param maturity The expiration/tenor pair.
   * @return The volatility.
   */
  

	

  

	

  /**
   * Gets the standard swap generator for which the volatility surface is valid.
   * @return The swap generator.
   */
  

	

  /**
   * Gets the volatility surface.
   * @return The volatility surface.
   */
  

	

  

	

  


}
