/**
 * Copyright (C) 2011 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.util.surface; 

import java.util.HashMap; 
import java.util.Map; 
import java.util.Set; 

import org.apache.commons.lang.ObjectUtils; 
import org.apache.commons.lang.Validate; 

import com.opengamma.util.tuple.DoublesPair; 

import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * Object to represent values linked to a surface (pair of doubles) for which the values can be added or multiplied by a constant. 
 * Used for different sensitivities (SABR, FX,...). The objects stored as a HashMap(DoublesPair, Double).
 */
    SurfaceValue {
	

  /**
   * The data stored as a map. Not null.
   */
  

	

  /**
   * Constructor. Create an empty map.
   */
  

	

  /**
   * Constructor from an existing map. The map is used in the new object.
   * @param map The map.
   */
  

	

  /**
   * Builder from on point.
   * @param point The surface point.
   * @param value The associated value.
   * @return The surface value.
   */
  

	

  /**
   * Builder from a map. A new map is created with the same values.
   * @param map The map.
   * @return The surface value.
   */
  

	

  /**
   * Builder from a SurfaceValue. A new map is created with the same values.
   * @param surface The SurfaceValue
   * @return The surface value.
   */
  

	

  /**
   * Gets the underlying map.
   * @return The map.
   */
  

	

  /**
   * Add a value to the object. The existing object is modified. If the point is not in the existing points of the object, it is put in the map.
   * If a point is already in the existing points of the object, the value is added to the existing value.
   * @param point The surface point.
   * @param value The associated value.
   */
  

	

  /**
   * Gets the number of elements in the map.
   * @return The number of elements.
   */
  

	

  /**
   * Create a new object containing the point of both initial objects. If a point is only on one surface, its value is the original value. 
   * If a point is on both surfaces, the values on that point are added.
   * @param value1 The first surface value.
   * @param value2 The second surface value.
   * @return The combined/sum surface value.
   */
  

	

  /**
   * Create a new object containing the point of the initial object and the new point. If the point is not in the existing points of the object, it is put in the map.
   * If a point is already in the existing point of the object, the value is added to the existing value.
   * @param surfaceValue The surface value.
   * @param point The surface point.
   * @param value The associated value.
   * @return The combined/sum surface value.
   */
  

	

  /**
   * Create a new object containing the point of the initial object with the all values multiplied by a given factor.
   * @param surfaceValue The surface value.
   * @param factor The multiplicative factor.
   * @return The multiplied surface.
   */
  

	

  /**
   * Compare two objects with a given tolerance. Return "true" if all the values are within the tolerance.
   * @param value1 The first object.
   * @param value2 The second object.
   * @param tolerance The tolerance.
   * @return The comparison flag.
   */
  

	

  /**
   * Collapse the object to a single value. The points on which the amounts occur are ignored and the values summed.
   * @return The value.
   */
  

	

  

	

  

	

  


}
