/**
 * Copyright (C) 2011 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.interestrate.market.description; 

import static com.opengamma.util.money.Currency.EUR; 
import static com.opengamma.util.money.Currency.USD; 
import static org.testng.AssertJUnit.assertEquals; 
import static org.testng.AssertJUnit.assertFalse; 

import java.util.ArrayList; 
import java.util.Arrays; 
import java.util.HashMap; 
import java.util.List; 
import java.util.Map; 

import org.testng.annotations.Test; 

import com.opengamma.analytics.financial.forex.method.FXMatrix; 
import com.opengamma.analytics.financial.interestrate.InterestRateCurveSensitivityUtils; 
import com.opengamma.analytics.financial.util.AssertSensivityObjects; 
import com.opengamma.util.money.Currency; 
import com.opengamma.util.tuple.DoublesPair; 
import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * Tests the MultipleCurrencyCurveSensitivityMarket class.
 */
    MultipleCurrencyCurveSensitivityMarketTest {
	

  

	
  

	
  

	
  

	
  static {
    SENSI_FWD_1.add(new MarketForwardSensitivity(0.5, 0.75, 0.26, 11));
    SENSI_FWD_1.add(new MarketForwardSensitivity(0.75, 1.00, 0.26, 12));
    SENSI_FWD_1.add(new MarketForwardSensitivity(1.00, 1.25, 0.24, 13));
  }

	
  

	
  

	
  

	

  

	
  

	
  

	
  

	
  

	
  static {
    SENSI_11.put(CURVE_NAME_1, SENSI_DATA_1);
    SENSI_22.put(CURVE_NAME_2, SENSI_DATA_2);
    SENSI_12.put(CURVE_NAME_1, SENSI_DATA_2);
    SENSI_33.put(CURVE_NAME_3, SENSI_DATA_3);
    SENSI_FWD_11.put(CURVE_NAME_2, SENSI_FWD_1);
  }

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	
  static {
    SENSI_FWD_1.add(new MarketForwardSensitivity(0.5, 0.75, 0.26, 11));
    SENSI_FWD_1.add(new MarketForwardSensitivity(0.75, 1.00, 0.26, 12));
    SENSI_FWD_1.add(new MarketForwardSensitivity(1.00, 1.25, 0.24, 13));
  }

	
  static {
    SENSI_11.put(CURVE_NAME_1, SENSI_DATA_1);
    SENSI_22.put(CURVE_NAME_2, SENSI_DATA_2);
    SENSI_12.put(CURVE_NAME_1, SENSI_DATA_2);
    SENSI_33.put(CURVE_NAME_3, SENSI_DATA_3);
    SENSI_FWD_11.put(CURVE_NAME_2, SENSI_FWD_1);
  }


}
