/**
 * Copyright (C) 2009 - present by OpenGamma Inc. and the OpenGamma group of
 * companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.math.rootfinding; 

import static com.opengamma.analytics.math.interpolation.Interpolator1DFactory.FLAT_EXTRAPOLATOR; 
import static com.opengamma.analytics.math.interpolation.Interpolator1DFactory.LINEAR_EXTRAPOLATOR; 
import static org.testng.AssertJUnit.assertEquals; 

import java.util.ArrayList; 
import java.util.List; 
import java.util.Map; 

import org.slf4j.Logger; 
import org.slf4j.LoggerFactory; 
import org.testng.annotations.BeforeMethod; 
import org.testng.annotations.Test; 

import com.opengamma.analytics.financial.interestrate.InstrumentDerivative; 
import com.opengamma.analytics.financial.interestrate.InstrumentDerivativeVisitor; 
import com.opengamma.analytics.financial.interestrate.MultipleYieldCurveFinderDataBundle; 
import com.opengamma.analytics.financial.interestrate.MultipleYieldCurveFinderFunction; 
import com.opengamma.analytics.financial.interestrate.ParRateCalculator; 
import com.opengamma.analytics.financial.interestrate.ParRateCurveSensitivityCalculator; 
import com.opengamma.analytics.financial.interestrate.PresentValueCalculator; 
import com.opengamma.analytics.financial.interestrate.PresentValueCurveSensitivityCalculator; 
import com.opengamma.analytics.financial.interestrate.YieldCurveBundle; 
import com.opengamma.analytics.financial.interestrate.swap.derivative.FixedFloatSwap; 
import com.opengamma.analytics.financial.model.interestrate.curve.YieldAndDiscountCurve; 
import com.opengamma.analytics.math.function.Function1D; 
import com.opengamma.analytics.math.interpolation.CombinedInterpolatorExtrapolator; 
import com.opengamma.analytics.math.interpolation.CombinedInterpolatorExtrapolatorFactory; 
import com.opengamma.analytics.math.interpolation.Interpolator1DFactory; 
import com.opengamma.analytics.math.matrix.DoubleMatrix1D; 
import com.opengamma.analytics.math.rootfinding.YieldCurveFittingTestDataBundle.TestType; 
import com.opengamma.analytics.math.rootfinding.newton.BroydenVectorRootFinder; 
import com.opengamma.analytics.math.rootfinding.newton.NewtonDefaultVectorRootFinder; 
import com.opengamma.analytics.math.rootfinding.newton.NewtonVectorRootFinder; 
import com.opengamma.analytics.math.rootfinding.newton.ShermanMorrisonVectorRootFinder; 
import com.opengamma.analytics.math.statistics.distribution.NormalDistribution; 
import com.opengamma.financial.convention.frequency.SimpleFrequency; 
import com.opengamma.util.tuple.DoublesPair; 
import com.opengamma.lambdava.tuple.DoublesPair; 

/**
 * 
 */
    YieldCurveFittingFromSwapsTest  extends YieldCurveFittingSetup {
	
  

	
  

	
  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  


}
