/**
 * Copyright (C) 2009 - present by OpenGamma Inc. and the OpenGamma group of companies
 *
 * Please see distribution for license.
 */
package com.opengamma.bbg.loader; 

import static com.opengamma.bbg.BloombergConstants.BLOOMBERG_DATA_SOURCE_NAME; 

import java.io.File; 
import java.io.FileReader; 
import java.io.IOException; 
import java.util.Collection; 
import java.util.Collections; 
import java.util.HashMap; 
import java.util.HashSet; 
import java.util.List; 
import java.util.Map; 
import java.util.Map.Entry; 
import java.util.Set; 

import org.apache.commons.io.FileUtils; 
import org.apache.commons.lang.StringUtils; 
import org.apache.commons.lang.builder.ToStringBuilder; 
import org.apache.commons.lang.builder.ToStringStyle; 
import org.slf4j.Logger; 
import org.slf4j.LoggerFactory; 
import org.threeten.bp.LocalDate; 
import org.threeten.bp.Month; 

import au.com.bytecode.opencsv.CSVReader; 

import com.google.common.collect.Lists; 
import com.google.common.collect.Maps; 
import com.google.common.collect.Sets; 
import com.opengamma.OpenGammaRuntimeException; 
import com.opengamma.bbg.BloombergConstants; 
import com.opengamma.bbg.util.BloombergDataUtils; 
import com.opengamma.bbg.util.BloombergDomainIdentifierResolver; 
import com.opengamma.core.id.ExternalSchemes; 
import com.opengamma.id.ExternalId; 
import com.opengamma.id.ExternalIdBundle; 
import com.opengamma.id.ExternalIdWithDates; 
import com.opengamma.id.ObjectId; 
import com.opengamma.id.UniqueId; 
import com.opengamma.master.historicaltimeseries.ExternalIdResolver; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesGetFilter; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesInfoDocument; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesInfoSearchRequest; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesMaster; 
import com.opengamma.master.historicaltimeseries.ManageableHistoricalTimeSeriesInfo; 
import com.opengamma.master.historicaltimeseries.impl.HistoricalTimeSeriesInfoSearchIterator; 
import com.opengamma.master.position.PositionMaster; 
import com.opengamma.provider.historicaltimeseries.HistoricalTimeSeriesProvider; 
import com.opengamma.util.ArgumentChecker; 
import com.opengamma.util.MapUtils; 
import com.opengamma.util.time.DateUtils; 
import com.opengamma.util.time.LocalDateRange; 
import com.opengamma.util.timeseries.localdate.LocalDateDoubleTimeSeries; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * Loader that manages the process of loading time-series information from Bloomberg.
 * <p>
 * This loads missing historical time-series data from Bloomberg.
 */
    BloombergHistoricalLoader {
	

  /** Logger. */
  

	

  

	

  

	
  

	
  

	
  

	

  

	
  

	
  

	
  

	
  

	
  

	
  

	
  

	
  

	
  

	

  

	

  /**
   * Gets the positionMaster field.
   * @return the positionMaster
   */
  

	

  /**
   * Sets the positionMaster field.
   * @param positionMaster  the positionMaster
   */
  

	

  /**
   * Gets the bbgUniqueId field.
   * @return the bbgUniqueId
   */
  

	

  /**
   * Sets the bbgUniqueId field.
   * @param bbgUniqueId  the bbgUniqueId
   */
  

	

  /**
   * Gets the csv field.
   * @return the csv
   */
  

	

  /**
   * Sets whether the files are in CSV format including the data provider for each identifier as a second column.
   * 
   * @param isCsv  <code>true</code> if the files are in CSV format
   */
  

	

  /**
   * Sets the dataProviders field.
   * @param dataProviders  the dataProviders
   */
  

	

  /**
   * Gets the dataProviders field.
   * @return the dataProviders
   */
  

	

  /**
   * Gets the dataFields field.
   * @return the dataFields
   */
  

	

  /**
   * Sets the dataFields field.
   * @param dataFields  the dataFields
   */
  

	

  /**
   * Sets the files field.
   * @param files  the files
   */
  

	
  
  /**
   * Sets the loadPositionMaster field.
   * @param loadPositionMaster  the loadPositionMaster
   */
  

	
  
  /**
   * Sets the updateDb field.
   * @param updateDb  the updateDb
   */
  

	
  
  /**
   * Sets the startDate field.
   * @param startDate  the startDate
   */
  

	
  
  /**
   * Sets the endDate field.
   * @param endDate  the endDate
   */
  

	
  
  /**
   * Sets the reload field.
   * @param reload  the reload
   */
  

	

  

	
  
  

	

  

	
  
  

	

  

	

  

	
  
  

	

  //-------------------------------------------------------------------------
  

	

  

	

  

	

  //-------------------------------------------------------------------------
  

	

  

	

  

	

  //-------------------------------------------------------------------------
  

	

  

	

  //-------------------------------------------------------------------------
      MetaDataKey {
		
    

		
    

		
    

		
    
    

		
    
    

		
    
    

		

    


	}

	

  //-------------------------------------------------------------------------
  


}
