/**
 * Copyright (C) 2009 - present by OpenGamma Inc. and the OpenGamma group of companies
 *
 * Please see distribution for license.
 */
package com.opengamma.bbg.loader; 

import static com.opengamma.bbg.BloombergConstants.BLOOMBERG_DATA_SOURCE_NAME; 
import static org.testng.AssertJUnit.assertEquals; 
import static org.testng.AssertJUnit.assertFalse; 
import static org.testng.AssertJUnit.assertNotNull; 
import static org.testng.AssertJUnit.assertTrue; 

import java.io.File; 
import java.util.ArrayList; 
import java.util.Arrays; 
import java.util.Collections; 
import java.util.HashMap; 
import java.util.List; 
import java.util.Map; 
import java.util.Set; 

import org.apache.commons.io.FileUtils; 
import org.slf4j.Logger; 
import org.slf4j.LoggerFactory; 
import org.springframework.jdbc.datasource.DataSourceTransactionManager; 
import org.testng.annotations.AfterMethod; 
import org.testng.annotations.BeforeMethod; 
import org.testng.annotations.Factory; 
import org.testng.annotations.Test; 
import org.threeten.bp.DayOfWeek; 
import org.threeten.bp.LocalDate; 

import com.google.common.collect.Lists; 
import com.google.common.collect.Maps; 
import com.google.common.collect.Sets; 
import com.opengamma.bbg.BloombergConnector; 
import com.opengamma.bbg.BloombergConstants; 
import com.opengamma.bbg.BloombergIdentifierProvider; 
import com.opengamma.bbg.referencedata.impl.BloombergReferenceDataProvider; 
import com.opengamma.bbg.test.BloombergTestUtils; 
import com.opengamma.core.historicaltimeseries.HistoricalTimeSeries; 
import com.opengamma.core.id.ExternalSchemes; 
import com.opengamma.id.ExternalId; 
import com.opengamma.id.ExternalIdBundle; 
import com.opengamma.id.ExternalIdBundleWithDates; 
import com.opengamma.id.ExternalIdWithDates; 
import com.opengamma.id.UniqueId; 
import com.opengamma.id.VersionCorrection; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesGetFilter; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesInfoDocument; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesInfoSearchRequest; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesInfoSearchResult; 
import com.opengamma.master.historicaltimeseries.HistoricalTimeSeriesMaster; 
import com.opengamma.master.historicaltimeseries.ManageableHistoricalTimeSeriesInfo; 
import com.opengamma.master.position.PositionMaster; 
import com.opengamma.masterdb.historicaltimeseries.DbHistoricalTimeSeriesMaster; 
import com.opengamma.masterdb.position.DbPositionMaster; 
import com.opengamma.provider.historicaltimeseries.HistoricalTimeSeriesProviderGetRequest; 
import com.opengamma.provider.historicaltimeseries.HistoricalTimeSeriesProviderGetResult; 
import com.opengamma.provider.historicaltimeseries.impl.AbstractHistoricalTimeSeriesProvider; 
import com.opengamma.util.db.DbConnector; 
import com.opengamma.util.test.DbTest; 
import com.opengamma.util.time.DateUtils; 
import com.opengamma.util.time.LocalDateRange; 
import com.opengamma.util.timeseries.localdate.ArrayLocalDateDoubleTimeSeries; 
import com.opengamma.util.timeseries.localdate.LocalDateDoubleTimeSeries; 
import com.opengamma.util.timeseries.localdate.MapLocalDateDoubleTimeSeries; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * Test.
 */
    BloombergHistoricalLoaderTest  extends DbTest {
	

  

	
  

	

  

	
  

	
  

	
  

	
  

	

  

	
  

	
  

	
  

	
  

	

  /**
   * Creates an instance specifying the database to run.
   * @param databaseType  the database type
   * @param databaseVersion  the database version
   */
  

	

  

	

  

	

  

	

  

	

  //-------------------------------------------------------------------------
  

	

  

	

  

	

  

	

      TestBulkHistoricalTimeSeriesProvider  extends AbstractHistoricalTimeSeriesProvider {
		
    //keep track of start date to use the same for reloading
    

		

    


	}

	

  

	

  

	

  

	

  //-------------------------------------------------------------------------
  // this test should be in another class, but shares a lot of setup
  


}
