/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 *
 * Please see distribution for license.
 */
package com.opengamma.engine.marketdata; 

import java.util.Map; 

import com.opengamma.core.id.ExternalIdOrderConfig; 
import com.opengamma.core.marketdatasnapshot.MarketDataValueType; 
import com.opengamma.engine.ComputationTargetSpecification; 
import com.opengamma.engine.function.MarketDataSourcingFunction; 
import com.opengamma.engine.marketdata.availability.MarketDataAvailability; 
import com.opengamma.engine.marketdata.availability.MarketDataAvailabilityProvider; 
import com.opengamma.engine.marketdata.availability.MarketDataNotSatisfiableException; 
import com.opengamma.engine.target.ComputationTargetReferenceVisitor; 
import com.opengamma.engine.target.ComputationTargetRequirement; 
import com.opengamma.engine.target.ComputationTargetType; 
import com.opengamma.engine.target.ComputationTargetTypeMap; 
import com.opengamma.engine.value.ValueProperties; 
import com.opengamma.engine.value.ValuePropertyNames; 
import com.opengamma.engine.value.ValueRequirement; 
import com.opengamma.engine.value.ValueSpecification; 
import com.opengamma.id.ExternalId; 
import com.opengamma.id.ExternalIdBundle; 
import com.opengamma.id.ExternalScheme; 
import com.opengamma.id.UniqueId; 
import com.opengamma.util.PublicAPI; 
import com.opengamma.util.functional.Function1; 
import com.opengamma.lambdava.functions.Function1; 

/**
 * Helper methods for working with the market data interfaces.
 */
    MarketDataUtils {
	

  

	

  

	

  /**
   * Returns the closest matching {@link MarketDataValueType} for a {@link ComputationTargetType}.
   * 
   * @param type the type to look up, not null
   * @return the market data value type
   */
  

	

  

	

  /**
   * Tests whether the requirement can be satisfied by the availability provider.
   * 
   * @param provider the provider to test, not null
   * @param requirement the requirement to test, not null
   * @return true if the requirement can be satisfied by the provider, false otherwise
   */
  

	

  /**
   * Tests whether the requirement can be satisfied by the availability provider.
   * 
   * @param provider the provider to test, not null
   * @param requirement the requirement to test, not null
   * @return one of the three availability states - see {@link MarketDataAvailability} for more details, not null
   */
  

	

  

	

  /**
   * Support function for extracting one of the external identifiers (based on the default order config) as the best available as a unique identifier for the target.
   */
  

	

  

	

  /**
   * Creates a specification that can be returned as a result by a data provider that satisfies the given requirement.
   * 
   * @param requirement the original requirement to be satisfied, not null
   * @param target the satisfying target identifier - to be used if the requirement did not include a unique identifier, not null
   * @return a satisfying value specification
   */
  

	

  /**
   * Creates a specification that can be returned as a result by a data provider that satisfied the given requirement.
   * 
   * @param requirement the original requirement to be satisfied, not null
   * @param target the satisfying target identifier - to be used if the requirement did not include a unique identifier, not null
   * @return a satisfying value specification
   */
  

	

  /**
   * Creates a specification that can be returned as a result by a data provider that satisfies the given requirement.
   * 
   * @param valueName the value name that is satisfied, not null
   * @param target the computation target, not null
   * @return a satisfying value specification
   */
  

	

  /**
   * Creates a specification that can be returned as a result by a data provider that satisfies the given requirement.
   * 
   * @param valueName the value name that is satisfied, not null
   * @param target the computation target, not null
   * @param properties the properties of the satisfying result, not null
   * @return a satisfying value specification
   */
  


}
