/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.engine.view; 

import java.util.HashMap; 
import java.util.Map; 
import java.util.Set; 
import java.util.concurrent.ConcurrentHashMap; 
import java.util.concurrent.locks.ReentrantLock; 

import com.opengamma.engine.depgraph.DependencyGraph; 
import com.opengamma.engine.depgraph.DependencyNode; 
import com.opengamma.engine.value.ValueSpecification; 
import com.opengamma.engine.view.compilation.CompiledViewDefinitionWithGraphsImpl; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * Represents a queryable source of the execution log mode to apply for a value specification.
 */
    ExecutionLogModeSource {
	

  

	
  

	
  

	
  

	
  
  /**
   * Ensures at least a minimum level of logging output is present in the results for the given value specifications.
   * Changes will take effect from the next computation cycle.
   * <p>
   * Each call to elevate the minimum level of logging output for a result must be paired with exactly one call to
   * reduce the level of logging output, if required.
   * 
   * @param minimumLogMode  the minimum log mode to ensure, not null
   * @param targets  the targets affected, not null or empty
   */
  

	
  
  /**
   * Gets the log mode for a dependency node.
   *
   * @param dependencyNode  the dependency node, not null
   * @return the log mode, not null
   */
  

	
  
  //-------------------------------------------------------------------------
  /*package*/ 

	
  
  

	
  
  

	
  
  

	
  
  

	
  
  

	
  
  

	
  
  //-------------------------------------------------------------------------
  

	
  
  


}
