/**
 * Copyright (C) 2009 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.engine.view.cache; 

import java.util.Collection; 
import java.util.HashMap; 
import java.util.LinkedList; 
import java.util.List; 
import java.util.Map; 
import java.util.concurrent.ConcurrentHashMap; 
import java.util.concurrent.ConcurrentMap; 
import java.util.concurrent.locks.ReentrantLock; 

import org.fudgemsg.FudgeContext; 
import org.fudgemsg.FudgeMsg; 

import com.opengamma.engine.value.ValueSpecification; 
import com.opengamma.id.UniqueId; 
import com.opengamma.util.ArgumentChecker; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * A {@link ViewComputationCacheSource} implementation based on {@link DefaultViewComputationCache} with
 * the given {@link IdentifierMap} and {@link FudgeMessageStore} objects supplied by the given
 * {@link FudgeMessageStoreFactory} instance.
 */
    DefaultViewComputationCacheSource   {
	

  /**
   * Callback to receive notification when a computation cycle's caches are released.
   */
      ReleaseCachesCallback {
		

    


	}

	

  /**
   * Callback to locate missing data.
   */
      MissingValueLoader {
		

    

		

    


	}

	

  

	
  

	

  

	
  

	
  

	
  

	
  

	

  

	
  

	

  

	

  

	

  /**
   * Gets the identifierMap field.
   * @return the identifierMap
   */
  

	

  /**
   * Gets the fudgeContext field.
   * @return the fudgeContext
   */
  

	

  <<<<<<< E:\ssmerge\fstmerge_tmp1502139572407\fstmerge_var1_7937728567955790266.java
@Override
  public ViewComputationCache cloneCache(UniqueId viewCycleId, String calculationConfigurationName) {
    final ViewComputationCacheKey key = new ViewComputationCacheKey(viewCycleId, calculationConfigurationName);
    final DefaultViewComputationCache cache = _cachesByKey.get(key);
    final InMemoryIdentifierMap identifierMap = new InMemoryIdentifierMap();
    final FudgeMessageStore dataStore = new DefaultFudgeMessageStore(new InMemoryBinaryDataStore(), getFudgeContext());
    for (Pair<ValueSpecification, FudgeMsg> value : cache) {
      dataStore.put(identifierMap.getIdentifier(value._1()), value._2());
    }
    return new DefaultViewComputationCache(identifierMap, dataStore, dataStore, getFudgeContext());
  }
=======
>>>>>>> E:\ssmerge\fstmerge_tmp1502139572407\fstmerge_var2_4721547992188179935.java


	

  

	

  

	

  

	

  

	

  

	

  /**
   * Override this method if you need to create a different sub-class of {@link DefaultViewComputationCache}.
   * 
   * @param identifierMap the identifier map
   * @param privateDataStore the message store for private values
   * @param sharedDataStore the message store for shared values 
   * @param fudgeContext the Fudge context
   * @return a new {@link DefaultViewComputationCache} instance
   */
  

	

  

	

  

	

  

	

  

	

  


}
