/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 *
 * Please see distribution for license.
 */
package com.opengamma.engine.view.cache; 

import java.util.AbstractCollection; 
import java.util.ArrayList; 
import java.util.Collection; 
import java.util.Iterator; 
import java.util.List; 
import java.util.Map; 
import java.util.Queue; 
import java.util.concurrent.ConcurrentLinkedQueue; 
import java.util.concurrent.ConcurrentMap; 
import java.util.concurrent.ExecutorService; 
import java.util.concurrent.atomic.AtomicInteger; 

import org.slf4j.Logger; 
import org.slf4j.LoggerFactory; 

import com.google.common.collect.MapMaker; 
import com.opengamma.engine.value.ComputedValue; 
import com.opengamma.engine.value.ValueSpecification; 
import com.opengamma.util.ArgumentChecker; 
import com.opengamma.util.async.AsynchronousExecution; 
import com.opengamma.util.async.AsynchronousOperation; 
import com.opengamma.util.async.ResultCallback; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * A {@link ViewComputationCache} that supports an asynchronous write behind update of the underlying cache.
 */
    WriteBehindViewComputationCache   {
	

  

	

      Entry {
		

    

		
    

		
    

		

    

		

    

		

    

		

    


	}

	

      ComputedValueCollection  extends AbstractCollection<ComputedValue> {
		

    

		

    

		

    

		

    


	}

	

      PendingLock {
		

    

		
    

		

    

		

    

		

    

		

    

		

    

		

    

		

    


	}

	

  

	
  

	
  /**
   * The in memory map contains all entries that are in the queues and have not been written to the underlying yet as well as values that have been retrieved from the underlying. Use of a soft
   * reference on the values will keep the values in memory for as long as possible so that the serialization/deserialization overhead of the underlying can probably be avoided for frequently used
   * objects.
   */
  

	
  

	
  

	
  

	

  

	
  

	
  

	

  

	
  

	
  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  /**
   * Starts the background writing thread to pass values to the underlying if it is not already started.
   */
  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  


}
