/**
 * Copyright (C) 2009 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.engine.view.calc; 

import java.util.Collections; 
import java.util.HashSet; 
import java.util.Set; 

import org.apache.commons.lang.ObjectUtils; 

import com.opengamma.engine.depgraph.DependencyGraph; 
import com.opengamma.engine.depgraph.DependencyNode; 
import com.opengamma.engine.value.ValueRequirement; 
import com.opengamma.engine.value.ValueSpecification; 
import com.opengamma.engine.view.cache.CacheSelectHint; 
import com.opengamma.engine.view.cache.ViewComputationCache; 
import com.opengamma.util.ArgumentChecker; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * Determines which nodes in a graph have changed. A node has 'changed' if and only 
 * if its subtree contains a node for which PreviousLiveDataInput != CurrentLiveDataInput.
 * Note that this excludes changes due to passage of the system clock. 
 */
    LiveDataDeltaCalculator {
	

  

	
  

	
  

	

  

	
  

	

  

	 // = false

  /**
   * For the delta calculation to be meaningful, the caches should be populated with LiveData 
   * inputs required to compute the given dependency graph. 
   * See {@link DependencyNode#getRequiredLiveData()}
   * and {@link ViewComputationCache#getValue(ValueSpecification)}.
   * 
   * @param graph Dependency graph
   * @param cache Contains CurrentLiveDataInputs (for the given graph)
   * @param previousCache Contains PreviousLiveDataInputs (for the given graph)
   */
  

	

  

	

  

	

  

	

  


}
