/**
 * Copyright (C) 2009 - present by OpenGamma Inc. and the OpenGamma group of companies
 *
 * Please see distribution for license.
 */
package com.opengamma.engine.view; 

import static org.testng.AssertJUnit.assertEquals; 
import static org.testng.AssertJUnit.assertNotNull; 
import static org.testng.AssertJUnit.assertNull; 

import java.math.BigDecimal; 
import java.util.Map; 

import org.testng.annotations.Test; 

import com.google.common.collect.Sets; 
import com.opengamma.core.position.Position; 
import com.opengamma.core.position.impl.SimplePortfolio; 
import com.opengamma.core.position.impl.SimplePortfolioNode; 
import com.opengamma.core.position.impl.SimplePosition; 
import com.opengamma.engine.ComputationTargetSpecification; 
import com.opengamma.engine.value.ComputedValueResult; 
import com.opengamma.engine.value.ValueProperties; 
import com.opengamma.engine.value.ValuePropertyNames; 
import com.opengamma.engine.value.ValueSpecification; 
import com.opengamma.engine.view.calc.DefaultAggregatedExecutionLog; 
import com.opengamma.engine.view.calcnode.MutableExecutionLog; 
import com.opengamma.id.ExternalIdBundle; 
import com.opengamma.id.UniqueId; 
import com.opengamma.util.log.LogLevel; 
import com.opengamma.util.log.SimpleLogEvent; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 *
 */
    ViewCalculationResultModelImplTest {
	

  

	
  

	
  

	
  

	
  

	

  static {
    PORTFOLIO = new SimplePortfolio("testportfolio");
    PORTFOLIO_ROOT_NODE = new SimplePortfolioNode(UniqueId.of("PortfolioIdentifier", "rootNode"), "rootNode");
    PORTFOLIO.setRootNode(PORTFOLIO_ROOT_NODE);
    PORTFOLIO_ROOT_NODE.addPosition(POSITION);

    final ExecutionLog executionLog = MutableExecutionLog.single(new SimpleLogEvent(LogLevel.INFO, "test"), ExecutionLogMode.FULL);
    final ExecutionLogWithContext executionLogWithContext = ExecutionLogWithContext.of("Mock", SPEC, executionLog);
    final AggregatedExecutionLog aggregatedExecutionLog = new DefaultAggregatedExecutionLog(executionLogWithContext, null, ExecutionLogMode.INDICATORS);
    COMPUTED_VALUE_RESULT = new ComputedValueResult(new ValueSpecification("DATA", SPEC, ValueProperties.with(ValuePropertyNames.FUNCTION, "mockFunctionId")
        .get()), "12345", aggregatedExecutionLog);
  }

	

  

	

  static {
    PORTFOLIO = new SimplePortfolio("testportfolio");
    PORTFOLIO_ROOT_NODE = new SimplePortfolioNode(UniqueId.of("PortfolioIdentifier", "rootNode"), "rootNode");
    PORTFOLIO.setRootNode(PORTFOLIO_ROOT_NODE);
    PORTFOLIO_ROOT_NODE.addPosition(POSITION);

    final ExecutionLog executionLog = MutableExecutionLog.single(new SimpleLogEvent(LogLevel.INFO, "test"), ExecutionLogMode.FULL);
    final ExecutionLogWithContext executionLogWithContext = ExecutionLogWithContext.of("Mock", SPEC, executionLog);
    final AggregatedExecutionLog aggregatedExecutionLog = new DefaultAggregatedExecutionLog(executionLogWithContext, null, ExecutionLogMode.INDICATORS);
    COMPUTED_VALUE_RESULT = new ComputedValueResult(new ValueSpecification("DATA", SPEC, ValueProperties.with(ValuePropertyNames.FUNCTION, "mockFunctionId")
        .get()), "12345", aggregatedExecutionLog);
  }


}
