/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 *
 * Please see distribution for license.
 */
package com.opengamma.financial.analytics.timeseries; 

import java.util.Collection; 
import java.util.Collections; 
import java.util.Set; 

import org.threeten.bp.LocalTime; 
import org.threeten.bp.ZoneId; 

import com.opengamma.DataNotFoundException; 
import com.opengamma.core.exchange.Exchange; 
import com.opengamma.core.exchange.ExchangeSource; 
import com.opengamma.core.position.PortfolioNode; 
import com.opengamma.core.position.Position; 
import com.opengamma.core.position.PositionOrTrade; 
import com.opengamma.core.region.Region; 
import com.opengamma.core.region.RegionSource; 
import com.opengamma.core.security.Security; 
import com.opengamma.engine.ComputationTarget; 
import com.opengamma.engine.function.FunctionCompilationContext; 
import com.opengamma.engine.target.ComputationTargetType; 
import com.opengamma.engine.value.ValueRequirement; 
import com.opengamma.engine.value.ValueRequirementNames; 
import com.opengamma.financial.OpenGammaCompilationContext; 
import com.opengamma.financial.property.DefaultPropertyFunction; 
import com.opengamma.financial.security.FinancialSecurityTypes; 
import com.opengamma.financial.security.FinancialSecurityUtils; 
import com.opengamma.id.ExternalId; 
import com.opengamma.id.VersionCorrection; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * Injection function to supply the valuation time and timezone for exchange traded instruments based on the exchange information. For other instruments that have a region, that is used to infer a
 * timezone.
 */
    HistoricalValuationFunctionDefaults  extends DefaultPropertyFunction {
	

  

	

  /**
   * Implementation for portfolio node targets. The default is injected based on the securities under the positions under this node.
   */
      PortfolioNodeDefaults  extends HistoricalValuationFunctionDefaults {
		

    

		

    

		

    


	}

	

  /**
   * Implementation for position or trade targets. The default is injected based on the security under the position.
   */
      PositionOrTradeDefaults  extends HistoricalValuationFunctionDefaults {
		

    

		

    


	}

	

  /**
   * Implementation for security targets. The default is injected based on the exchange the security is traded on.
   */
      SecurityDefaults  extends HistoricalValuationFunctionDefaults {
		

    

		

    


	}

	

      GetDefaults {
		

    

		
    

		

    

		

    


	}

	

  

	

  

	

  // DefaultPropertyFunction

  

	

  


}
