/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.curve;

import com.opengamma.lambdava.tuple.Pair;

/**
 * Build curves using bills and bonds.
 */
public class CurveConstructionBillBondTest {

    static {
        for (int loopbill = 0; loopbill < BILL_MATURITY.length; loopbill++) {
            BILL_SECURITY[loopbill] = new BillSecurityDefinition(CCY_USD, BILL_MATURITY[loopbill], NOTIONAL, SPOT_LAG_BILL, CALENDAR, YIELD_BILL_USGOVT, DAY_COUNT_BILL_USGOVT, NAME_COUNTERPART);
            GENERATOR_BILL[loopbill] = new GeneratorBill("GeneratorBill" + loopbill, BILL_SECURITY[loopbill]);
        }
    }

    static {
        CCY_MAP.put(CURVE_NAME_DSC_USD, CCY_USD);
        CCY_MAP.put(CURVE_NAME_GOVTUS_USD, CCY_USD);
    }

    static {
        DEFINITIONS_DSC_USD = getDefinitions(DSC_USD_MARKET_QUOTES, DSC_USD_GENERATORS, DSC_USD_TENOR);
        DEFINITIONS_GOVTUS_USD = getDefinitions(GOVTUS_USD_MARKET_QUOTES, GOVTUS_USD_GENERATORS, GOVTUS_USD_TENOR);
        for (int loopblock = 0; loopblock < NB_BLOCKS; loopblock++) {
            DEFINITIONS_UNITS[loopblock] = new InstrumentDefinition<?>[NB_UNITS[loopblock]][][];
            GENERATORS_UNITS[loopblock] = new GeneratorYDCurve[NB_UNITS[loopblock]][];
            NAMES_UNITS[loopblock] = new String[NB_UNITS[loopblock]][];
        }
        DEFINITIONS_UNITS[0][0] = new InstrumentDefinition<?>[][] { DEFINITIONS_DSC_USD };
        DEFINITIONS_UNITS[0][1] = new InstrumentDefinition<?>[][] { DEFINITIONS_GOVTUS_USD };
        final GeneratorYDCurve genIntLin = new GeneratorCurveYieldInterpolated(MATURITY_CALCULATOR, INTERPOLATOR_LINEAR);
        GENERATORS_UNITS[0][0] = new GeneratorYDCurve[] { genIntLin };
        GENERATORS_UNITS[0][1] = new GeneratorYDCurve[] { genIntLin };
        NAMES_UNITS[0][0] = new String[] { CURVE_NAME_DSC_USD };
        NAMES_UNITS[0][1] = new String[] { CURVE_NAME_GOVTUS_USD };
    }
    // Calculators
}
