/**
 * Copyright (C) 2012 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.analytics.financial.curve;

import com.opengamma.lambdava.tuple.ObjectsPair;
import com.opengamma.lambdava.tuple.Pair;

/**
 * Data for the testing of curve construction with FX swaps and XCCy swaps
 */
public class YieldCurveConstructionGeneratorTwoCurrenciesXCcyData {

    static {
        DEFINITIONS_DSC_1 = getDefinitions(DSC_1_MARKET_QUOTES, DSC_1_GENERATORS, DSC_1_TENOR);
        DEFINITIONS_FWD_1 = getDefinitions(FWD_1_MARKET_QUOTES, FWD_1_GENERATORS, FWD_1_TENOR);
        DEFINITIONS_DSC_2 = getDefinitions(DSC_2_MARKET_QUOTES, DSC_2_GENERATORS, DSC_2_TENOR);
        DEFINITIONS_FWD_2 = getDefinitions(FWD_2_MARKET_QUOTES, FWD_2_GENERATORS, FWD_2_TENOR);
        CCY_MAP.put(CURVE_NAME_DSC_1, CCY1);
        CCY_MAP.put(CURVE_NAME_FWD_1, CCY1);
        CCY_MAP.put(CURVE_NAME_DSC_2, CCY2);
        CCY_MAP.put(CURVE_NAME_FWD_2, CCY2);
    }

    /**
   * Curve types used in the curve construction
   */
    enum CurveType {

    }
}
