/**
 * Copyright (C) 2009 - present by OpenGamma Inc. and the OpenGamma group of companies
 * 
 * Please see distribution for license.
 */
package com.opengamma.engine.view.calc; 

import java.util.ArrayList; 
import java.util.Collection; 
import java.util.Collections; 
import java.util.HashMap; 
import java.util.HashSet; 
import java.util.Iterator; 
import java.util.LinkedList; 
import java.util.List; 
import java.util.Map; 
import java.util.NavigableMap; 
import java.util.Queue; 
import java.util.Set; 
import java.util.TreeMap; 
import java.util.concurrent.Future; 
import java.util.concurrent.atomic.AtomicInteger; 

import org.slf4j.Logger; 
import org.slf4j.LoggerFactory; 

import com.google.common.collect.Sets; 
import com.opengamma.engine.depgraph.DependencyGraph; 
import com.opengamma.engine.depgraph.DependencyNode; 
import com.opengamma.engine.value.ValueSpecification; 
import com.opengamma.engine.view.ExecutionLogModeSource; 
import com.opengamma.engine.view.cache.CacheSelectHint; 
import com.opengamma.engine.view.calc.stats.GraphExecutorStatisticsGatherer; 
import com.opengamma.engine.view.calcnode.CalculationJob; 
import com.opengamma.engine.view.calcnode.CalculationJobSpecification; 
import com.opengamma.engine.view.calcnode.JobResultReceiver; 
import com.opengamma.engine.view.calcnode.stats.FunctionCosts; 
import com.opengamma.id.VersionCorrection; 
import com.opengamma.util.async.Cancelable; 
import com.opengamma.util.monitor.OperationTimer; 
import com.opengamma.util.tuple.Pair; 
import com.opengamma.lambdava.tuple.Pair; 

/**
 * This DependencyGraphExecutor executes the given dependency graph as a number of dependent jobs suitable for a number of calculation nodes to exploit parallelism from the dependency graph.
 */
    MultipleNodeExecutor   {
	

  

	

  

	
  

	
  

	
  

	
  

	
  

	
  

	
  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  /**
   * Partitions the graph and starts it executing. The future returned corresponds to the whole graph. Once an execution plan is built it is cached for future use.
   * 
   * @param graph  the graph to execute, not null
   * @param executionResultQueue  a queue to feed intermediate job result notifications to, not null
   * @param statistics  the statistics reporter, not null
   * @param logModeSource  the execution log mode source, not null
   * @return a future that indicates complete execution of the graph
   */
  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  

	

  /**
   * Finds pairs of nodes with the same input set (i.e. that would execute concurrently) that are below the minimum job size and merge them together.
   */
  

	

  /**
   * If a fragment has only one dependency, and both it and its dependent are below the maximum job size they are merged.
   */
  

	

  /**
   * If a fragment has only a single input, it can be a tail to the fragment generating that input. A fragment with multiple inputs can be a tail to all of them iff they are tails to a common fragment
   * (i.e. all will end up at the same node).
   */
  

	

  

	

  


}
